/*
 * JORAM: Java(TM) Open Reliable Asynchronous Messaging
 * Copyright (C) 2004 - 2025 ScalAgent Distributed Technologies
 * Copyright (C) 2004 Bull SA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): Frederic Maistre (Bull SA)
 * Contributor(s): Nicolas Tachker (ScalAgent D.T.)
 */
package org.objectweb.joram.client.connector;

import java.io.Serializable;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.IllegalStateException;
import javax.jms.JMSContext;
import javax.jms.JMSException;
import javax.jms.JMSRuntimeException;
import javax.jms.JMSSecurityException;
import javax.jms.JMSSecurityRuntimeException;
import javax.naming.Reference;
import javax.resource.Referenceable;
import javax.resource.ResourceException;
import javax.resource.spi.CommException;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.SecurityException;

import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;

import fr.dyade.aaa.common.Debug;

/**
 * An <code>OutboundConnectionFactory</code> instance is used for
 * getting a connection to an underlying JORAM server.
 */
public class OutboundConnectionFactory implements ConnectionFactory, Serializable, Referenceable {
  /** define serialVersionUID for interoperability */
  private static final long serialVersionUID = 1L;
  
  private static final Logger logger = Debug.getLogger(OutboundConnectionFactory.class.getName());
  private static final boolean DEBUG = logger.isLoggable(BasicLevel.DEBUG);
  
  /** Central manager for outbound connectivity. */
  protected ManagedConnectionFactoryImpl mcf;
  /** Manager for connection pooling. */
  protected ConnectionManager cxManager;

  /** Naming reference of this instance. */
  protected Reference reference;

  /**
   * Constructs an <code>OutboundConnectionFactory</code> instance.
   *
   * @param mcf        Central manager for outbound connectivity.
   * @param cxManager  Manager for connection pooling.
   */
  OutboundConnectionFactory(ManagedConnectionFactoryImpl mcf, ConnectionManager cxManager) {
    if (DEBUG)
      logger.log(BasicLevel.DEBUG, "OutboundConnectionFactory(" + mcf + ", " + cxManager + ")");

    this.mcf = mcf;
    if (cxManager != null) {
      this.cxManager = cxManager;
    } else {
      this.cxManager = DefaultConnectionManager.getRef();
    }
  }

  // ************************************************************
  // Implementation of Referenceable
  // ************************************************************
  
  /** Sets the naming reference of this factory. */
  @Override
  public void setReference(Reference ref) {
    this.reference = ref;
  }

  /** Returns the naming reference of this factory. */
  @Override
  public Reference getReference()  {
    return reference;
  }

  // ************************************************************
  // Implementation of ConnectionFactory
  // ************************************************************

  /**
   * Requests a connection for the default user, eventually returns an
   * <code>OutboundConnection</code> instance.
   *
   * @exception JMSSecurityException   If connecting is not allowed.
   * @exception IllegalStateException  If the underlying JORAM server
   *                                   is not reachable.
   * @exception JMSException           Generic exception.
   */
  @Override
  public Connection createConnection() throws JMSException {
    if (DEBUG)
      logger.log(BasicLevel.DEBUG, this + " createConnection()");

    return createConnection(mcf.getUserName(), mcf.getPassword());
  }

  /**
   * Requests a connection for a given user, eventually returns an
   * <code>OutboundConnection</code> instance.
   *
   * @exception JMSSecurityException   If connecting is not allowed.
   * @exception IllegalStateException  If the underlying JORAM server
   *                                   is not reachable.
   * @exception JMSException           Generic exception.
   */
  @Override
  public Connection createConnection(String userName, String password) throws JMSException {
    if (DEBUG)
      logger.log(BasicLevel.DEBUG, this + " createConnection(" + userName + ", ****)");

    try {
      ConnectionRequest cxRequest = null;
      if (mcf instanceof ManagedQueueConnectionFactoryImpl)
        cxRequest = new QueueConnectionRequest(userName, password, mcf.getIdentityClass());
      else if (mcf instanceof ManagedTopicConnectionFactoryImpl)
        cxRequest = new TopicConnectionRequest(userName, password, mcf.getIdentityClass());
      else
        cxRequest = new ConnectionRequest(userName, password, mcf.getIdentityClass());

      if (DEBUG)
        logger.log(BasicLevel.DEBUG, this + " createConnection cxManager = " + cxManager);

      Object o = cxManager.allocateConnection(mcf, cxRequest);

      if (DEBUG)
        logger.log(BasicLevel.DEBUG, this + " createConnection connection = " + o);

      return (Connection) o;
    } catch (SecurityException exc) {
      throw new JMSSecurityException("Invalid user identification: " + exc);
    } catch (CommException exc) {
      throw new IllegalStateException("Could not connect to the JORAM server: " + exc);
    } catch (ResourceException exc) {
      throw new JMSException("Could not create connection: " + exc);
    }
  }

  @Override
  public JMSContext createContext() {
    try {
      return new org.objectweb.joram.client.jms.JMSContext(createConnection());
    } catch (JMSSecurityException e) {
      logger.log(BasicLevel.ERROR, "Unable to create JMSContext", e);
      throw new JMSSecurityRuntimeException("Unable to create JMSContext", e.getMessage(), e);
    } catch (JMSException e) {
      logger.log(BasicLevel.ERROR, "Unable to create JMSContext", e);
      throw new JMSRuntimeException("Unable to create JMSContext", e.getMessage(), e);
    }
  }

  @Override
  public JMSContext createContext(String userName, String password) {
    try {
      return new org.objectweb.joram.client.jms.JMSContext(createConnection(userName, password));
    } catch (JMSSecurityException e) {
      logger.log(BasicLevel.ERROR, "Unable to create JMSContext", e);
      throw new JMSSecurityRuntimeException("Unable to create JMSContext", e.getMessage(), e);
    } catch (JMSException e) {
      logger.log(BasicLevel.ERROR, "Unable to create JMSContext", e);
      throw new JMSRuntimeException ("Unable to create JMSContext", e.getMessage(), e);
    }
  }

  @Override
  public JMSContext createContext(String userName, String password, int sessionMode) {
    try {
      return new org.objectweb.joram.client.jms.JMSContext(createConnection(userName, password), sessionMode);
    } catch (JMSSecurityException e) {
      logger.log(BasicLevel.ERROR, "Unable to create JMSContext", e);
      throw new JMSSecurityRuntimeException("Unable to create JMSContext", e.getMessage(), e);
    } catch (JMSException e) {
      logger.log(BasicLevel.ERROR, "Unable to create JMSContext", e);
      throw new JMSRuntimeException ("Unable to create JMSContext", e.getMessage(), e);
    }
  }

  @Override
  public JMSContext createContext(int sessionMode) {
    try {
      return new org.objectweb.joram.client.jms.JMSContext(createConnection(), sessionMode);
    } catch (JMSSecurityException e) {
      logger.log(BasicLevel.ERROR, "Unable to create JMSContext", e);
      throw new JMSSecurityRuntimeException("Unable to create JMSContext", e.getMessage(), e);
    } catch (JMSException e) {
      logger.log(BasicLevel.ERROR, "Unable to create JMSContext", e);
      throw new JMSRuntimeException ("Unable to create JMSContext", e.getMessage(), e);
    }
  }
}
